summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorThomas Deutschmann <whissi@gentoo.org>2020-12-22 19:02:42 +0100
committerThomas Deutschmann <whissi@gentoo.org>2020-12-22 19:03:08 +0100
commit4de3eb82a3e100c3f3895c3e188ea2427d0bfc4e (patch)
tree84ff34640a4340b2eba53cb5d6773108bf7919f4
parentnet-analyzer/tracebox: migrate to lua-single.eclass (diff)
downloadgentoo-4de3eb82a3e100c3f3895c3e188ea2427d0bfc4e.tar.gz
gentoo-4de3eb82a3e100c3f3895c3e188ea2427d0bfc4e.tar.bz2
gentoo-4de3eb82a3e100c3f3895c3e188ea2427d0bfc4e.zip
sys-kernel/linux-firmware: bump to v20201218
Package-Manager: Portage-3.0.12, Repoman-3.0.2 Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>
-rw-r--r--sys-kernel/linux-firmware/Manifest1
-rw-r--r--sys-kernel/linux-firmware/linux-firmware-20201218.ebuild355
2 files changed, 356 insertions, 0 deletions
diff --git a/sys-kernel/linux-firmware/Manifest b/sys-kernel/linux-firmware/Manifest
index 6c97fe6ba2f..b919046ef9f 100644
--- a/sys-kernel/linux-firmware/Manifest
+++ b/sys-kernel/linux-firmware/Manifest
@@ -6,3 +6,4 @@ DIST linux-firmware-20200721.tar.xz 118013188 BLAKE2B 648f22d63e8e8a791e3243f9af
DIST linux-firmware-20200817.tar.xz 121401548 BLAKE2B 77a9ddbab368994801c5f834b65e0c991798eb5ecaeecb84a5b69e886f7aae6e6186f60ebdd4f18449ffe639fb8230c3db108151026161ab23740da63be928a2 SHA512 dba347534d1b51ebcc55600c05293fad5f04f0bfdaec80b2ba27b40a9a20eb5c8bd76cb29d8ca6c814b067952cba4ee3fdb903510a171df98959d592b2c00c13
DIST linux-firmware-20200918.tar.xz 124581736 BLAKE2B 1541e1afcf52dfb03e89a1d2960b447b9a7e056267eea71ca468c85a69a777ac8686500acd1d65d30943ef82ad64c64c9b29773c92f1d5ea0d1f68212f001da7 SHA512 c257bb40d7c4746e50f3733928c992017d57e3fac641bc63ea41754de50c5adb05ba1629e750b3943cc28e5d19ae709e5cdd3fbbe9ea35563bc68707e0e98e80
DIST linux-firmware-20201022.tar.xz 129328580 BLAKE2B 8845fa18aad56a1164a0ba63533bc44f728e0b6c207cf9c695bb432bbd33f3740f3d10958f2fd4cad9f45653751819b8e8eaab4b593f5aa0edaed3a246fbd6bc SHA512 d502000154483d4aa8274f851749c1da550f3e94152ae950c93b3577af72e8864b1884938b7b02c4ea832af4b3060bccea10fdee4cd1dd83cb3ca8edcbf2995e
+DIST linux-firmware-20201218.tar.xz 137880408 BLAKE2B 32839d61d743ade53aad7df0c87e90c28c9eff2e40e8072ebb283907c9a3800b7a0020a3c4ea2350f691ebd7ad9c5d71a1a83991c9099cd9b9bc5f9a908732c9 SHA512 9dfce57ad8d23939860d0b005cbbc80227c67e9739479473b1e36a5d32392df1d341eba3a85c0e243590841954dae298913e96168e72c68eeb3762dfd65a38b3
diff --git a/sys-kernel/linux-firmware/linux-firmware-20201218.ebuild b/sys-kernel/linux-firmware/linux-firmware-20201218.ebuild
new file mode 100644
index 00000000000..2a607fbbde5
--- /dev/null
+++ b/sys-kernel/linux-firmware/linux-firmware-20201218.ebuild
@@ -0,0 +1,355 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+inherit mount-boot savedconfig
+
+# In case this is a real snapshot, fill in commit below.
+# For normal, tagged releases, leave blank
+MY_COMMIT=
+
+if [[ ${PV} == 99999999* ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://git.kernel.org/pub/scm/linux/kernel/git/firmware/${PN}.git"
+else
+ if [[ -n "${MY_COMMIT}" ]]; then
+ SRC_URI="https://git.kernel.org/cgit/linux/kernel/git/firmware/linux-firmware.git/snapshot/${MY_COMMIT}.tar.gz -> ${P}.tar.gz"
+ else
+ SRC_URI="https://mirrors.edge.kernel.org/pub/linux/kernel/firmware/${P}.tar.xz"
+ fi
+
+ KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~mips ppc ppc64 s390 sparc x86"
+fi
+
+DESCRIPTION="Linux firmware files"
+HOMEPAGE="https://git.kernel.org/?p=linux/kernel/git/firmware/linux-firmware.git"
+
+LICENSE="GPL-2 GPL-2+ GPL-3 BSD MIT || ( MPL-1.1 GPL-2 )
+ redistributable? (
+ linux-fw-redistributable ( BSD-2 BSD BSD-4 ISC MIT no-source-code ) )
+ unknown-license? ( all-rights-reserved )"
+SLOT="0"
+IUSE="initramfs +redistributable savedconfig unknown-license"
+REQUIRED_USE="initramfs? ( redistributable )"
+
+RESTRICT="binchecks strip test
+ unknown-license? ( bindist )"
+
+BDEPEND="initramfs? ( app-arch/cpio )"
+
+#add anything else that collides to this
+RDEPEND="!savedconfig? (
+ redistributable? (
+ !sys-firmware/alsa-firmware[alsa_cards_ca0132]
+ !net-dialup/ueagle-atm
+ !net-dialup/ueagle4-atm
+ !sys-block/qla-fc-firmware
+ !sys-firmware/iwl1000-ucode
+ !sys-firmware/iwl6005-ucode
+ !sys-firmware/iwl6030-ucode
+ !sys-firmware/iwl6050-ucode
+ !sys-firmware/iwl3160-ucode
+ !sys-firmware/iwl7260-ucode
+ !sys-firmware/iwl3160-7260-bt-ucode
+ !sys-firmware/raspberrypi-wifi-ucode
+ )
+ unknown-license? (
+ !sys-firmware/alsa-firmware[alsa_cards_korg1212]
+ !sys-firmware/alsa-firmware[alsa_cards_maestro3]
+ !sys-firmware/alsa-firmware[alsa_cards_sb16]
+ !sys-firmware/alsa-firmware[alsa_cards_ymfpci]
+ )
+ )"
+
+QA_PREBUILT="*"
+
+pkg_pretend() {
+ use initramfs && mount-boot_pkg_pretend
+}
+
+src_unpack() {
+ if [[ ${PV} == 99999999* ]]; then
+ git-r3_src_unpack
+ else
+ default
+ # rename directory from git snapshot tarball
+ if [[ ${#GIT_COMMIT} -gt 8 ]]; then
+ mv ${PN}-*/ ${P} || die
+ fi
+ fi
+}
+
+src_prepare() {
+ default
+
+ find . -type f -not -perm 0644 -print0 \
+ | xargs --null --no-run-if-empty chmod 0644 \
+ || die
+
+ chmod +x copy-firmware.sh || die
+
+ if use initramfs; then
+ if [[ -d "${S}/amd-ucode" ]]; then
+ local UCODETMP="${T}/ucode_tmp"
+ local UCODEDIR="${UCODETMP}/kernel/x86/microcode"
+ mkdir -p "${UCODEDIR}" || die
+ echo 1 > "${UCODETMP}/early_cpio"
+
+ local amd_ucode_file="${UCODEDIR}/AuthenticAMD.bin"
+ cat "${S}"/amd-ucode/*.bin > "${amd_ucode_file}" || die "Failed to concat amd cpu ucode"
+
+ if [[ ! -s "${amd_ucode_file}" ]]; then
+ die "Sanity check failed: '${amd_ucode_file}' is empty!"
+ fi
+
+ pushd "${UCODETMP}" &>/dev/null || die
+ find . -print0 | cpio --quiet --null -o -H newc -R 0:0 > "${S}"/amd-uc.img
+ popd &>/dev/null || die
+ if [[ ! -s "${S}/amd-uc.img" ]]; then
+ die "Failed to create '${S}/amd-uc.img'!"
+ fi
+ else
+ # If this will ever happen something has changed which
+ # must be reviewed
+ die "'${S}/amd-ucode' not found!"
+ fi
+ fi
+
+ # whitelist of misc files
+ local misc_files=(
+ copy-firmware.sh
+ WHENCE
+ README
+ )
+
+ # whitelist of images with a free software license
+ local free_software=(
+ # keyspan_pda (GPL-2+)
+ keyspan_pda/keyspan_pda.fw
+ keyspan_pda/xircom_pgs.fw
+ # dsp56k (GPL-2+)
+ dsp56k/bootstrap.bin
+ # ath9k_htc (BSD GPL-2+ MIT)
+ ath9k_htc/htc_7010-1.4.0.fw
+ ath9k_htc/htc_9271-1.4.0.fw
+ # pcnet_cs, 3c589_cs, 3c574_cs, serial_cs (dual GPL-2/MPL-1.1)
+ cis/LA-PCM.cis
+ cis/PCMLM28.cis
+ cis/DP83903.cis
+ cis/NE2K.cis
+ cis/tamarack.cis
+ cis/PE-200.cis
+ cis/PE520.cis
+ cis/3CXEM556.cis
+ cis/3CCFEM556.cis
+ cis/MT5634ZLX.cis
+ cis/RS-COM-2P.cis
+ cis/COMpad2.cis
+ cis/COMpad4.cis
+ # serial_cs (GPL-3)
+ cis/SW_555_SER.cis
+ cis/SW_7xx_SER.cis
+ cis/SW_8xx_SER.cis
+ # dvb-ttpci (GPL-2+)
+ av7110/bootcode.bin
+ # usbdux, usbduxfast, usbduxsigma (GPL-2+)
+ usbdux_firmware.bin
+ usbduxfast_firmware.bin
+ usbduxsigma_firmware.bin
+ # brcmfmac (GPL-2+)
+ brcm/brcmfmac4330-sdio.Prowise-PT301.txt
+ brcm/brcmfmac43340-sdio.meegopad-t08.txt
+ brcm/brcmfmac43362-sdio.cubietech,cubietruck.txt
+ brcm/brcmfmac43362-sdio.lemaker,bananapro.txt
+ brcm/brcmfmac43430a0-sdio.jumper-ezpad-mini3.txt
+ "brcm/brcmfmac43430a0-sdio.ONDA-V80 PLUS.txt"
+ brcm/brcmfmac43430-sdio.AP6212.txt
+ brcm/brcmfmac43430-sdio.Hampoo-D2D3_Vi8A1.txt
+ brcm/brcmfmac43430-sdio.MUR1DX.txt
+ brcm/brcmfmac43430-sdio.raspberrypi,3-model-b.txt
+ brcm/brcmfmac43455-sdio.raspberrypi,3-model-b-plus.txt
+ brcm/brcmfmac4356-pcie.gpd-win-pocket.txt
+ # isci (GPL-2)
+ isci/isci_firmware.bin
+ # carl9170 (GPL-2+)
+ carl9170-1.fw
+ # atusb (GPL-2+)
+ atusb/atusb-0.2.dfu
+ atusb/atusb-0.3.dfu
+ atusb/rzusb-0.3.bin
+ # mlxsw_spectrum (dual BSD/GPL-2)
+ mellanox/mlxsw_spectrum-13.1420.122.mfa2
+ mellanox/mlxsw_spectrum-13.1530.152.mfa2
+ mellanox/mlxsw_spectrum-13.1620.192.mfa2
+ mellanox/mlxsw_spectrum-13.1702.6.mfa2
+ mellanox/mlxsw_spectrum-13.1703.4.mfa2
+ mellanox/mlxsw_spectrum-13.1910.622.mfa2
+ mellanox/mlxsw_spectrum-13.2000.1122.mfa2
+ )
+
+ # blacklist of images with unknown license
+ local unknown_license=(
+ atmsar11.fw
+ korg/k1212.dsp
+ ess/maestro3_assp_kernel.fw
+ ess/maestro3_assp_minisrc.fw
+ yamaha/ds1_ctrl.fw
+ yamaha/ds1_dsp.fw
+ yamaha/ds1e_ctrl.fw
+ tr_smctr.bin
+ ttusb-budget/dspbootcode.bin
+ emi62/bitstream.fw
+ emi62/loader.fw
+ emi62/midi.fw
+ emi62/spdif.fw
+ ti_3410.fw
+ ti_5052.fw
+ mts_mt9234mu.fw
+ mts_mt9234zba.fw
+ whiteheat.fw
+ whiteheat_loader.fw
+ intelliport2.bin
+ cpia2/stv0672_vp4.bin
+ vicam/firmware.fw
+ edgeport/boot.fw
+ edgeport/boot2.fw
+ edgeport/down.fw
+ edgeport/down2.fw
+ edgeport/down3.bin
+ sb16/mulaw_main.csp
+ sb16/alaw_main.csp
+ sb16/ima_adpcm_init.csp
+ sb16/ima_adpcm_playback.csp
+ sb16/ima_adpcm_capture.csp
+ sun/cassini.bin
+ acenic/tg1.bin
+ acenic/tg2.bin
+ adaptec/starfire_rx.bin
+ adaptec/starfire_tx.bin
+ yam/1200.bin
+ yam/9600.bin
+ 3com/3C359.bin
+ ositech/Xilinx7OD.bin
+ qlogic/isp1000.bin
+ myricom/lanai.bin
+ yamaha/yss225_registers.bin
+ lgs8g75.fw
+ )
+
+ if use !unknown-license; then
+ einfo "Removing files with unknown license ..."
+ rm -v "${unknown_license[@]}" || die
+ fi
+
+ if use !redistributable; then
+ # remove files _not_ in the free_software or unknown_license lists
+ # everything else is confirmed (or assumed) to be redistributable
+ # based on upstream acceptance policy
+ einfo "Removing non-redistributable files ..."
+ local OLDIFS="${IFS}"
+ local IFS=$'\n'
+ set -o pipefail
+ find ! -type d -printf "%P\n" \
+ | grep -Fvx -e "${misc_files[*]}" -e "${free_software[*]}" -e "${unknown_license[*]}" \
+ | xargs -d '\n' --no-run-if-empty rm -v
+
+ [[ ${?} -ne 0 ]] && die "Failed to remove non-redistributable files"
+
+ IFS="${OLDIFS}"
+ fi
+
+ restore_config ${PN}.conf
+}
+
+src_install() {
+ ./copy-firmware.sh -v "${ED}/lib/firmware" || die
+
+ pushd "${ED}/lib/firmware" &>/dev/null || die
+
+ # especially use !redistributable will cause some broken symlinks
+ einfo "Removing broken symlinks ..."
+ find * -xtype l -print -delete || die
+
+ if use savedconfig; then
+ if [[ -s "${S}/${PN}.conf" ]]; then
+ local files_to_keep="${T}/files_to_keep.lst"
+ grep -v '^#' "${S}/${PN}.conf" 2>/dev/null > "${files_to_keep}" || die
+ [[ -s "${files_to_keep}" ]] || die "grep failed, empty config file?"
+
+ einfo "Applying USE=savedconfig; Removing all files not listed in config ..."
+ find ! -type d -printf "%P\n" \
+ | grep -Fvx -f "${files_to_keep}" \
+ | xargs -d '\n' --no-run-if-empty rm -v
+
+ if [[ ${PIPESTATUS[0]} -ne 0 ]]; then
+ die "Find failed to print installed files"
+ elif [[ ${PIPESTATUS[1]} -eq 2 ]]; then
+ # grep returns exit status 1 if no lines were selected
+ # which is the case when we want to keep all files
+ die "Grep failed to select files to keep"
+ elif [[ ${PIPESTATUS[2]} -ne 0 ]]; then
+ die "Failed to remove files not listed in config"
+ fi
+ fi
+ fi
+
+ # remove empty directories, bug #396073
+ find -type d -empty -delete || die
+
+ # sanity check
+ if ! ( shopt -s failglob; : * ) 2>/dev/null; then
+ eerror "No files to install. Check your USE flag settings"
+ eerror "and the list of files in your saved configuration."
+ die "Refusing to install an empty package"
+ fi
+
+ # create config file
+ echo "# Remove files that shall not be installed from this list." > "${S}"/${PN}.conf || die
+ find * ! -type d >> "${S}"/${PN}.conf || die
+ save_config "${S}"/${PN}.conf
+
+ popd &>/dev/null || die
+
+ if use initramfs ; then
+ insinto /boot
+ doins "${S}"/amd-uc.img
+ fi
+}
+
+pkg_preinst() {
+ if use savedconfig; then
+ ewarn "USE=savedconfig is active. You must handle file collisions manually."
+ fi
+
+ # Make sure /boot is available if needed.
+ use initramfs && mount-boot_pkg_preinst
+}
+
+pkg_postinst() {
+ elog "If you are only interested in particular firmware files, edit the saved"
+ elog "configfile and remove those that you do not want."
+
+ local ver
+ for ver in ${REPLACING_VERSIONS}; do
+ if ver_test ${ver} -lt 20190514; then
+ elog
+ elog 'Starting with version 20190514, installation of many firmware'
+ elog 'files is controlled by USE flags. Please review your USE flag'
+ elog 'and package.license settings if you are missing some files.'
+ break
+ fi
+ done
+
+ # Don't forget to umount /boot if it was previously mounted by us.
+ use initramfs && mount-boot_pkg_postinst
+}
+
+pkg_prerm() {
+ # Make sure /boot is mounted so that we can remove /boot/amd-uc.img!
+ use initramfs && mount-boot_pkg_prerm
+}
+
+pkg_postrm() {
+ # Don't forget to umount /boot if it was previously mounted by us.
+ use initramfs && mount-boot_pkg_postrm
+}